* 1 gtmask.F
* PACKAGE GTMASK  !" ޥ
*********************************************************************
      PROGRAM GTMASK
*
* 1 d:\dennou\gt3-dcl5\include/gtsinc.F
* PACKAGE GTSINC  !" ΰ礭(IJKDIMΤ̣߰)
*****************************************************************
      PARAMETER  ( IDIM=256 )
      PARAMETER  ( JDIM=128 )
      PARAMETER  ( KDIM=17  )
      PARAMETER  ( IJKDIM=IDIM*JDIM*KDIM )
      
* 1 d:\dennou\gt3-dcl5\include/gzsize.F
* 10 gtmask.F
      INTEGER    NCC, NDC, NED, NFILN
      PARAMETER  ( NCC=16, NDC=64, NED=8 )
      PARAMETER  ( NFILN=100 )
* 11 gtmask.F
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD1( NDC )*(NCC)
      REAL       GDATA1( IJKDIM )
      CHARACTER  HHEAD2( NDC )*(NCC)
      REAL       GDATA2( IJKDIM )
      CHARACTER  HFILE( 2 ) *(NFILN)
      DATA       HFILE  / '$GTTMPDIR/gtool.out',
     &                    '$GTTMPDIR/gtool.out' /
      INTEGER    IFILE( 2 ) 
      DATA       IFILE  / 50, 51 /
      DATA       JFILE  / 60 /
      LOGICAL    OFIRST
*
      PARAMETER  ( RUNDEF=-999., IUNDEF=-999 )
      REAL       RMIN, RMAX
      DATA       RMIN, RMAX   / 2*RUNDEF /
      LOGICAL    SINGLE
      DATA       SINGLE / .FALSE. /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET /4*' '/
*
      DATA       EDIT, ETTL /'MSK','<gtmask>'/
*
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   MASK
*
      NAMELIST  /OPTION/ RMIN, RMAX, SINGLE, OUT , APND, 
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE

*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD1, IJKDIM )
      CALL GTSIZE ( HHEAD2, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( HFILE( 2 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE( 1 ), HFILE( 1 ) )
      IF ( HFILE( 1 ) .NE. HFILE( 2 ) ) THEN
         CALL GFROPN ( IFILE( 2 ), HFILE( 2 ) )
      ENDIF
      CALL GFOOPN ( JFILE, OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL RNGSET( RMIN, RMAX )
*
      OFIRST = .TRUE.
 1100 CONTINUE
*
         CALL   GFREAD
     O        ( HHEAD1, GDATA1, IEOD1 ,
     I          IFILE( 1 ), 1               )
*
         IF ( (.NOT.SINGLE) .OR. OFIRST ) THEN
            IEOD2 = 0
            IF ( HFILE( 1 ) .NE. HFILE( 2 ) ) THEN
               CALL   GFREAD
     O        ( HHEAD2, GDATA2, IEOD2 ,
     I          IFILE( 2 ), 1               )
            ELSE
               CALL   GPFSET
     I        ( HHEAD1, GDATA1,
     I          '  '  , '  '  ,
     O          HHEAD2, GDATA2  )
               WRITE (6,*) '** DUPLEX'
            ENDIF
            OFIRST = .FALSE.
         ENDIF
*
         IF ( MAX( IEOD1,IEOD2 ) .EQ. 0 ) THEN
*
            CALL GMCAL2
     I         ( MASK  ,
     M           HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           EDIT  , ETTL  )
*
           IF ( ITEM .NE. ' ' ) THEN
              CALL GHCSET( HHEAD1, 'ITEM', ITEM )
           ENDIF
           IF ( UNIT .NE. ' ' ) THEN
              CALL GHCSET( HHEAD1, 'UNIT', UNIT )
           ENDIF
           IF ( TITLE .NE. ' ' ) THEN
              CALL GHCSTS( HHEAD1, 'TITL', TITLE )
           ENDIF
           IF ( DSET .NE. ' ' ) THEN
              CALL GHCSET( HHEAD1, 'DSET', DSET )
           ENDIF
*
           IF ( GRESET ) THEN
              CALL GHRSGP( HHEAD1 )
           ENDIF
*
           CALL  GFWRIT
     I         ( HHEAD1, GDATA1,
     I           JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE MASK
     I         ( HHEAD , GDATA ,
     I           HHEADM, GDATAM,
     O           HHEADS, GDATAS,
     D           IXDIM , IYDIM , IZDIM ,
     D           IXDIM2, IYDIM2, IZDIM2 )
*
      CHARACTER  HHEAD  ( * ) *(*)
      CHARACTER  HHEADM ( * ) *(*)
      CHARACTER  HHEADS ( * ) *(*)
      REAL       GDATA  ( * )
      REAL       GDATAM ( * )
      REAL       GDATAS ( * )
      REAL       VMISS
*
      PARAMETER  ( RUNDEF=-999. )
      CALL GLPGET( 'RMISS', VMISS )
*
      DO 1100 I = 1, IXDIM*IYDIM*IZDIM
         IF      ( RMIN .NE. RUNDEF .AND. GDATAM(I) .LT. RMIN ) THEN
            GDATAS( I ) = VMISS
         ELSE IF ( RMAX .NE. RUNDEF .AND. GDATAM(I) .GT. RMAX ) THEN
            GDATAS( I ) = VMISS
         ELSE IF ( GDATAM(I) .EQ. VMISS ) THEN
            GDATAS( I ) = VMISS
         ELSE
            GDATAS( I ) = GDATA( I )            
         ENDIF
 1100 CONTINUE
*
      RETURN
*=================================================================
      ENTRY      RNGSET
     I         ( RMIN1, RMAX1 )
      RMIN = RMIN1
      RMAX = RMAX1
      RETURN
      END
