* 1 gtset.F
* PACKAGE GTSET   !" ͤΥå
*********************************************************************
      PROGRAM GTSET
*
* 1 d:\dennou\gt3-dcl5\include/gtsinc.F
* PACKAGE GTSINC  !" ΰ礭(IJKDIMΤ̣߰)
*****************************************************************
      PARAMETER  ( IDIM=256 )
      PARAMETER  ( JDIM=128 )
      PARAMETER  ( KDIM=17  )
      PARAMETER  ( IJKDIM=IDIM*JDIM*KDIM )
      
* 1 d:\dennou\gt3-dcl5\include/gzsize.F
* 10 gtset.F
      INTEGER    NCC, NDC, NED, NFILN
      PARAMETER  ( NCC=16, NDC=64, NED=8 )
      PARAMETER  ( NFILN=100 )
* 11 gtset.F
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE  / '$GTTMPDIR/gtool.out' /
      INTEGER    IFILE
      DATA       IFILE  / 50 /
      DATA       JFILE  / 60 /
*
      CHARACTER  HNUL *3
      PARAMETER  ( RUNDEF=-999., IUNDEF=-999, HNUL='NUL')
      REAL       OFS , FACT
      DATA       OFS , FACT   / 0.0, 1.0 /
      REAL       RMIN, RMAX
      DATA       RMIN, RMAX   / 2*RUNDEF /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL / 6*HNUL /
      REAL       DIVS , DIVL
      REAL       DMIN , DMAX
      REAL       DMISS, ROPTN
      DATA       DIVS , DIVL, DMIN, DMAX, DMISS, ROPTN / 6*RUNDEF /
      INTEGER    TIME
      INTEGER    TDUR
      DATA       TIME, TDUR  / 2*IUNDEF /
      CHARACTER  UTIM   *(NCC)
      CHARACTER  DATE   *(NCC)
      DATA       UTIM, DATE  / 2*HNUL /
      CHARACTER  AITM1  *(NCC)
      CHARACTER  AITM2  *(NCC)
      CHARACTER  AITM3  *(NCC)
      DATA       AITM1, AITM2, AITM3 / 3*HNUL /
      INTEGER    STYP
      DATA       STYP  / IUNDEF /
      INTEGER    IOPTN 
      DATA       IOPTN / IUNDEF /
      CHARACTER  COPTN  *(NCC)
      DATA       COPTN / HNUL  /
*
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   RNGEXC
*
      NAMELIST  /OPTION/ OFS , FACT, OUT, APND, RMIN, RMAX,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL,
     &                   DIVS, DIVL, DMIN, DMAX, DMISS, STYP,
     &                   TIME, TDUR, UTIM, DATE,
     &                   AITM1, AITM2, AITM3,
     &                   ROPTN, IOPTN, COPTN, GRESET, HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
      CALL GFOOPN ( JFILE,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL RNGSET( RMIN, RMAX )
*
 1100 CONTINUE
*
         CALL   GFREAD
     O        ( HHEAD, GDATA, IEOD ,
     I          IFILE , 1               )
*
         IF ( IEOD .EQ. 0 ) THEN
*
           IF ( RMIN .NE. RUNDEF .OR. RMAX .NE. RUNDEF ) THEN
              CALL GMCAL1
     I        ( RNGEXC,
     I          HHEAD , GDATA,
     I          '   ' , '   '     )
           ENDIF
           IF ( OFS .NE. 0.0 ) THEN
              CALL GMFINC
     I        ( HHEAD, GDATA, OFS  ,
     I          '  '  , '  '           )
           ENDIF
           IF ( FACT .NE. 1.0 ) THEN
              CALL GMFFCT
     I        ( HHEAD, GDATA, FACT ,
     I          '  '  , '  '           )
           ENDIF
*
           IF (  ( EDIT .NE. ' ' ).AND.( EDIT .NE. HNUL )  ) THEN
              CALL GHEADD ( HHEAD, EDIT, ETTL )
           ENDIF
*
           IF ( ITEM .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'ITEM', ITEM )
           ENDIF
           IF ( UNIT .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'UNIT', UNIT )
           ENDIF
           IF ( TITLE .NE. HNUL ) THEN
              CALL GHCSTS( HHEAD, 'TITL', TITLE )
           ENDIF
           IF ( DSET .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'DSET', DSET )
           ENDIF
*
           IF ( GRESET ) THEN
              CALL GHRSGP( HHEAD  )
           ENDIF
           IF ( DIVS .NE. RUNDEF ) THEN
              CALL GHPSET( HHEAD, 'DIVS', DIVS )
           ENDIF
           IF ( DIVL .NE. RUNDEF ) THEN
              CALL GHPSET( HHEAD, 'DIVL', DIVL )
           ENDIF
           IF ( DMIN .NE. RUNDEF ) THEN
              CALL GHPSET( HHEAD, 'DMIN', DMIN )
           ENDIF
           IF ( DMAX .NE. RUNDEF ) THEN
              CALL GHPSET( HHEAD, 'DMAX', DMAX )
           ENDIF
           IF ( DMISS .NE. RUNDEF ) THEN
              CALL GHPSET( HHEAD, 'MISS', DMISS )
           ENDIF
           IF ( TIME  .NE. IUNDEF ) THEN
              CALL GHPSET( HHEAD, 'TIME', TIME )
           ENDIF
           IF ( TDUR  .NE. IUNDEF ) THEN
              CALL GHPSET( HHEAD, 'TDUR', TDUR )
           ENDIF
           IF ( UTIM  .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'UTIM', UTIM )
           ENDIF
           IF ( DATE  .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'DATE', DATE )
           ENDIF
           IF ( AITM1 .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'AITM1', AITM1 )
           ENDIF
           IF ( AITM2 .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'AITM2', AITM2 )
           ENDIF
           IF ( AITM3 .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'AITM3', AITM3 )
           ENDIF
           IF ( ROPTN .NE. RUNDEF ) THEN
              CALL GHPSET( HHEAD, 'ROPTN', ROPTN )
           ENDIF
           IF ( STYP .NE. IUNDEF ) THEN
              CALL GHPSET( HHEAD, 'STYP', STYP )
           ENDIF
           IF ( IOPTN .NE. IUNDEF ) THEN
              CALL GHPSET( HHEAD, 'IOPTN', IOPTN )
           ENDIF
           IF ( COPTN .NE. HNUL ) THEN
              CALL GHCSET( HHEAD, 'COPTN', COPTN )
           ENDIF
*
           CALL  GFWRIT
     I         ( HHEAD , GDATA ,
     I           JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE RNGEXC
     I         ( HHEAD , GDATA ,
     O           HHEADS, GDATAS,
     D           IXDIM , IYDIM , IZDIM )
*
      CHARACTER  HHEAD  ( * ) *(*)
      CHARACTER  HHEADS ( * ) *(*)
      REAL       GDATA  ( * )
      REAL       GDATAS ( * )
      REAL       VMISS
*
      PARAMETER  ( RUNDEF=-999. )
      CALL GLPGET( 'RMISS', VMISS )
*
      DO 1100 I = 1, IXDIM*IYDIM*IZDIM
         IF      ( RMIN .NE. RUNDEF .AND. GDATA(I) .LT. RMIN ) THEN
            GDATAS( I ) = VMISS
         ELSE IF ( RMAX .NE. RUNDEF .AND. GDATA(I) .GT. RMAX ) THEN
            GDATAS( I ) = VMISS
         ELSE
            GDATAS( I ) = GDATA( I )            
         ENDIF
 1100 CONTINUE
*
      RETURN
*=================================================================
      ENTRY      RNGSET
     I         ( RMIN1, RMAX1 )
      RMIN = RMIN1
      RMAX = RMAX1
      RETURN
      END
